#include <iostream>
#include <fstream>
#include <string>
#include "ffinterpreter.hh"

// f*ckf*ckb**b, a f*ckf*ck interpreter
// by Fredrik Arnerup

int main(int argc, char **argv) {        
  using namespace std;

  if(argc != 2) {
    cerr << "Usage: ffb sourcefile" << endl;
    exit(1);
  }
  
  if(string(argv[1]) == "--help") {        
    cout << "f*ckf*ckb**b v0.2 by Fredrik Arnerup" << endl
	 << "  Usage: ffb sourcefile" << endl
	 << "  Input taken from stdin" << endl
	 << "  Output to stdout" << endl;
    exit(0);
  }

  ifstream in(argv[1]);
  if(!in) {
    cerr << "Error opening " << argv[1] << " for input" << endl;
    exit(1);
  }

  FFInterpreter ff(cin, cout, cerr);
  try {
    ff.parse(in);
    ff.run();
  } catch (exception e) {
    cerr << e.what() << endl;
    exit(1);
  }
  return 0;
}
