#include <stdexcept>
#include <iostream>
#include <vector>
#include "tourettemachine.hh"

// f*ckf*ck interpreter by Fredrik Arnerup

class FFInterpreter {
public:

  FFInterpreter(std::istream &input, std::ostream &output, 
		std::ostream &error);
  
  // parse source code
  void parse(std::istream &src);

  // run program after it has been parsed
  void run();

private:
  enum instruction {FUCK, SHAG, BOOB, TITS, COCK, KNOB, ARSE, BUTT};
  typedef std::vector<instruction> Program;
  Program program;

  std::istream &in;
  std::ostream &out, &err;
  int ip;
  bool inside_comment;
  instruction last_instruction;
  TouretteMachine tm;

  instruction get_instruction(std::istream &src);
  
  void execute_instruction(Program::const_iterator &ip);

  void print_instruction(std::ostream &out, instruction inst, 
			 bool censor = true);
};
